package ca.virology.japafi.structures;
import java.io.Serializable;


public class Pattern implements Serializable
{
	private static final long serialVersionUID = -3230705850675222275L;
	private IndexPair [] _elements;
	private int _length;
	
	public Pattern()
	{
		
	}
	public Pattern(int size)
	{
		_length=size;
		_elements=new IndexPair[_length];
	}
	
	public Pattern(IndexPair [] elements)
	{
		_elements=elements;
		_length=elements.length;
	}
	
	
	public int length()
	{
		return _length;
	}
	
	public void setInterval(int index, IndexPair interval)
	{
		_elements[index]=interval;
	}
	
	public IndexPair getInterval(int index)
	{
		return _elements[index];
	}
	
	public IndexPair [] getAllIntervals()
	{
		return _elements;
	}
	
	public String toString()
	{
		String ret="";
		for(int i=0;i<_elements.length;i++)
		{
			if(_elements==null)
				return "null";
			if(_elements[i]==null)
				ret+="null"+" ";
			else
				ret+=_elements[i].toString()+" ";
		}
		return ret;
	}
}
