package ca.virology.japafi.tests;

import java.util.BitSet;
import java.util.List;

import ca.virology.japafi.algorithms.APBT;
import ca.virology.japafi.utils.SequenceFileReader;
import ca.virology.japafi.utils.Util;

public class TestAPBT 
{
	public static void main(String [] args)
	{
		
		String file1=null;		
		String file2=null;
		int maxDiff=0;
		int minLen=0;			
		
		try
		{
			file1=args[0];		
			file2=args[1];
			
			minLen=Integer.parseInt(args[2]);
			maxDiff=Integer.parseInt(args[3]);
			
			
		}
		catch(Exception e)
		{
			System.out.println("Usage: \n" + 
					"java -Xmx512M -Xms512m -classpath classes ca.virology.japafi.algorithms.TestAPBTBoolean \\ \n" +
            		"<filename1> <filename2> \n" +
            		"<minLength> <maxDifferences> " );
			System.exit(1);
		}	


		
		System.out.println("APBT algorithm");					
		
		
		SequenceFileReader reader=new SequenceFileReader(file1);
		char [] seq1=reader.getSequence().toCharArray();
		
		
		reader=new SequenceFileReader(file2);
		char [] seq2=reader.getSequence().toCharArray();
		
		APBT algorithm=new APBT(seq1,seq2,
				minLen,maxDiff);
		
		long start=System.currentTimeMillis();
		algorithm.process();
		
		long howlong=System.currentTimeMillis()-start;
		System.out.println("Processed in "+howlong+" ms.");
		List solutions=algorithm.getSolutions();
		System.out.println("Produced output size="+solutions.size());
		
		//System.out.println("The solutions are: "+solutions);
	}			
}
