package ca.virology.japafi.tests;

import java.util.BitSet;

import ca.virology.japafi.application.*;
import ca.virology.japafi.utils.SequenceFileReader;
import ca.virology.japafi.utils.Util;

public class TestApplication 
{
	public static void main(String [] args)
	{
		String [] files=null ;		
		
		int maxDiff=0;
		int minLen=0;			
		
		try
		{		
			minLen=Integer.parseInt(args[0]);
			maxDiff=Integer.parseInt(args[1]);
			
			files=new String [args.length-2] ;	
			for(int i=2;i<args.length;i++)
			{
				files[i-2]=args[i];
			}			
		}
		catch(Exception e)
		{
			System.out.println("Usage: \n" + 
					"java -Xmx512M -Xms512m -classpath classes ca.virology.japafi.algorithms.TestApplication \\ \n" +
            		"<filename1> <filename2> ... <filenameN>\n" +
            		"<minLength> <maxDifferences> " );
			System.exit(1);
		}	


		
		System.out.println("Pattern finder");					
		
		char [][] sequences=new char [files.length][];
		for(int i=0;i<sequences.length;i++)
		{
			SequenceFileReader reader=new SequenceFileReader(files[i]);
			sequences[i]=reader.getSequence().toCharArray();
		}
		
		BitSet oldStartPositions=new BitSet(sequences[0].length);
		oldStartPositions.set(0,sequences[0].length-1);
		
		long start=System.currentTimeMillis();
		
		PatternFinder finder=new PatternFinder(sequences,minLen, maxDiff);
		finder.preProcess();
		System.out.println("Pre processed in "+(System.currentTimeMillis()-start)+" ms.");
		
		System.out.println("Total pattern groups : "+finder.getTotalPatternGroups());
		start=System.currentTimeMillis();
		finder.process();
		System.out.println("Processed in "+(System.currentTimeMillis()-start)+" ms.");
		finder.printSolutions();
	}
}
